syms('n','i','j','k','l','m');
fprintf(1,'Introduzca m, numero de mallas horizontales\n');
m = input(' ');
fprintf(1,'Introduzca n, numero de mallas verticales\n');
n = input(' ');
i = m;
j = n;
TRUE = 1;
FALSE = 0;
close;%cierra pantallas anteriores
title('Numeracion de mallas y aristas');
xlabel('columnas');
ylabel('filas');
axis([-1 m+1 -1 n+1]);%pone ejes hasta m+1 y n+1
hold on;
while j ~= -1;
    i = m;
    while i~=0;%hace m lineas
        x=[i-0.05 i-0.95];%coordinadas x de 1 linea
        y=[j j];%coordenadas y de una linea
        plot(x,y);
        i=i-1;

    end;
    j=j-1;
end;
i=m;
while i~=-1
    j=n;
    while j~=0;%hace n colunmas
        y=[j-0.05 j-0.95];%coordinadas y de lineas horizontales
        x=[i i];%coordinadas x de lineas horizontales
        plot(x,y);
        j=j-1;
    end;
      i=i-1;
end;
%Numeracion de las aristas y de las mallas, para facilitarle el programa al usuario%
II=zeros(1,m*n);
for i=1:m*n
    II(1,i)=i;
end
Int=num2str(II);%Convertimos el vector intensidad en vector cadena
h=isspace(Int);%Vector de ceros y unos
w=length(h);% Longitud del vector h
A=0;
b=0.5;
e=1;% Contador del vector intensidad y h
ww=0;
for t=1:n
    for j=0:(m-1)
            x=j+0.4;
           while h(e)==0 & e<=w-1
                    y=b+(n-1); 
                    text(x,y,Int(e),'Color',[0 1 0]);% Se inserta el valor de cada intensidad en el centro de cada celda
                    x=x+0.1;
                    e=e+1;

            end
            while h(e)==1 & e<=w-1
                e=e+1;
            end
            if e==w & j==m-1 & ww==0
                b=0.5;
                y=b;
                text(x,y,Int(w),'Color',[0 1 0]); %Se inserta el valor de la ultima intensidad en su celda correspondiente         
                ww=ww+1;
            end
     end
     b=b-1;
 end

%Numeracion de las aristas%
NN=zeros(1,2*m*n+m+n);
for i=1:2*m*n+n+m
    NN(1,i)=i;    
end
p=num2str(NN);
h=isspace(p);
z=length(h);
e=1;
b=0;
c=0.5;
for a=1:n+1

    for j=0:(m-1)
            x=j+0.5;
            
           while h(e)==0 & e<=z-1

                    y=n+b;
                    
                    text(x,y,p(e),'Color',[1 0 0]);
                    x=x+0.1;
                    e=e+1;

            end
            while h(e)==1  & e<=z-1
                e=e+1;
            end
            if e==z & j==m-1
                y=n+b;
                
                text(x,y,p(z),'Color',[1 0 0]);
                      
            end
     end

    for i=0:(m)
         x=i;
           while h(e)==0 & e<=z-1

                    y=(n-1)+c;
                    text(x,y,p(e),'Color',[1 0 0]);
                    x=x+0.1;
                    e=e+1;

            end
            while h(e)==1 & e<=z-1
                e=e+1;
            end
        end

    b=b-1;
    c=c-1;
end

%segunda parte
%declaracion de las aristas de cada celda, las cuales han sido numeradas

A=zeros(2*n+1,2*m+1);
format long
k=1;
for j=1:2*n+1
% El inicio del sistema, eleccin de -1 o lnea 0 segn j
   if round(j/2)==j/2
       for i=1:2*m+1
            if round(i/2)==i/2
                A(j,i)=0;
            else
                A(j,i)=k;
                k=k+1;
            end
        end      
    else
        for i=1:2*m+1
            if round(i/2)==i/2
                A(j,i)=k;
                k=k+1;
            else
                A(j,i)=-1;
            end
        end 
    end
end
C=zeros (m*n,4);
k=0;
for j=1:n
	for i=1:m
		z=m*(j-1)+i;
		C(z,1)=A(k+j,2*i);
		C(z,2)=A(k+j+2,2*i);
        C(z,3)=A(k+j+1,2*i-1);
		C(z,4)=A(k+j+1,2*i+1);
	end						
	k=k+1;
end
C=C
% Obtencin de la matriz de mallas comunes de las resistencias
O=zeros(2*m*n+n+m,2);
u=1;
k=2*m+2;
for i=1: n-1
	for j=k: k+m-1
		O(j,1)=u;
		u=u+m;
		O(j,2)=u;
		if j~= k+m-1
			u=u-m+1;
		else
			u=u-m;
		end
	end
	k=k+2*m+1;
	u=u+1;
end
% Algoritmo para colocar los nmeros de las mallas de las resistencias verticales que
% se comparten
u=1;
k=0;
for i=1: n
	for j=k+m+2: k+2*m
		O(j,1)=u;
		u=u+1;
		O(j,2)=u;
	end
u=u+1;
k=k+2*m+1;
end
% Algoritmo para colocar el nmero de la malla en la que se encuentran las
% resistencias horizontales sin compartir
u=1;
k=0;
for i=1:2
	for j=k+1: k+m;
		O(j,1)=u;
		O(j,2)=u;
		u=u+1;
	end
	k=n*m+n*(m+1);
	u=m*(n-1)+1;
end
% Algoritmo para colocar el nmero de la malla en la que se encuentran las
% resistencias verticales sin compartir 
u=1;
k=m;
for i=1: 2
	for j=1:n
		O(k+1,1)=u;
        O(k+1,2)=u;
        k=k+2*m+1;
        u=u+m;
    end
	k=2*m;
	u=m;
end
A=A
O=O
f=zeros(5*n*m+2*n+2*m,1);
fprintf(1,'Eleccin del sistema de adquisicin de los datos del circuito\n');
fprintf(1,'1. Pantalla\n');
fprintf(1,'2. Fichero de texto\n');
fprintf(1,'Escriba 1 o 2\n');
AA = input(' ');
DR=zeros(2*n*m+m+n,4);
V=zeros(2*n*m+n+m,1);
R=zeros(2*m*n+m+n,1);
T=zeros(2*m*n+n+m,1);
I=zeros(m*n,1);
if AA==1
    % Adquisicin de los datos de las resistencias por el usuario
       for i=1:2*n*m+n+m
        fprintf('escribir para la resistencia n, las siguientes constantes\n')
        i=i
        fprintf('a\n')
        DR(i,1)=input('');
        fprintf('b\n')
        DR(i,2)=input('');
        fprintf('c\n')
        DR(i,3)=input('');
        fprintf('a continuacin escriba el valor del Area\n');
        DR(i,4)=input('');
    end
    % Adquisicin de los valores de las tensiones de las fuentes de tensiones
    % en voltios de las mallas
    fprintf('Escribir el valor de la fuente teniendo en cuenta que: cualquier fuente\n')
    fprintf('que se halle en una arista vertical ser positiva si pasa de un polo \n')
    fprintf('si pasa de un polo negativo a positivo de abajo a arriba y cualquier\n')
    fprintf('fuente que se halle en una arista horizontal ser positiva siempre\n')
    fprintf('que pase de negativo a positivo de izquierda a derecha\n')
    for i=1: 2*n*m+m+n
        i=i
        V(i,1)=input('');
    end
    % Adquisicin de las aproximaciones por el usuario de los valores de las
    % resistencias
    for j=1: 2*m*n+n+m
        fprintf('escribir aproximacin de la resistencia\n')
        j=j
        R(j,1)=input('');
    end
    % Adquisicin de las aproximaciones por el usuario de los valores de las
    % temperaturas
    for j=1: 2*n*m+n+m
        fprintf('escribir aproximacin de la temperatura n\n')
        j=j
        T(j,1)=input('');
    end
    % Adquisicin de las aproximaciones por el usuario de los valores de las
    % intensidades
    for j=1: m*n
        fprintf('escribir aproximacin de la intensidad n\n')
        j=j
        I(j,1)=input('');
    end
end
if AA==2 
    % Adquisicin de los parmtros de las resistencias y de las fuenteas de
    % tensin por fichero
    ADDRYT=zeros (2*m*n+n+m,5);
    fprintf(1,'Peticin de los coeficientes de las resistencias y de las fuentes de tensin/s\n');
    fprintf(1,'Siga por favor las instrucciones adecuadamente\n');
    fprintf(1,'\n');
    fprintf(1,'1 El fichero tendr 4 columnas de nmeros\n');
    fprintf(1,'2 El fichero tendr 2*m*n+n+m filas (el nmero aristas totales o el nmero mximo de resistencias en el circuito )\n');
    fprintf(1,'3 Deje una separacin entre cada uno de los nmeros de cada fila\n');
    fprintf(1,'4 Las filas coinciden con la numeracin de las resistencias y por tanto de las fuentes de tensin\n');
    fprintf(1,'5 El orden de las columnas de izquierda a derecha ser de la constante a en ohmios de la resistencia, la\n');
    fprintf(1,'   contante b en ohmios por Kelvin^-1, la contante c en ohmios por Kelvin^-2, y el valor de la fuente de tensin\n');
    fprintf(1,'6 El carcter positivo o negativo de la fuente de tensin que deber poner el usuario no depender de la intensidad, \n');
    fprintf(1,'   sino de la positicin de forma de ejes de coordenadas. Para cualquiera de las resistencias verticales, si pasa de negativo \n');
    fprintf(1,'   a positivo desde el nudo inferior al nudo superior (en referencia a la altura) ser positiva. Y para cualquier horizontal \n');
    fprintf(1,'   si a la derecha del nudo origen a la derecha tiene el positivo, entonces el valor de la fuente de tensin ser positiva\n');
    fprintf(1,'7 Si no existe un resistencia o ms, todos los datos de la misma se podrn cero, al igual que las fuentes de tensin\n');
    fprintf(1,'\n');
    fprintf(1,'Escriba el nombre del fichero en la forma - disco:\\nombre.ext\n');
    fprintf(1,'Por ejemplo:   A:\\DATA.DTA\n');
    NAME = input(' ','s');
    INP = fopen(NAME,'rt');
    for i = 1 : 2*m*n+n+m
        for j = 1:5
            ADDRYT(i,j) = fscanf(INP, '%f',1);
        end
    end
    fclose(INP);
    for i=1: 2*m*n+n+m
        for j=1:4
            DR(i,j)=ADDRYT(i,j);
        end
        for i=1:2*m*n+n+m
            V(i,1)=ADDRYT(i,5);
        end
    end
    % Adquisicin de las aproximaciones de la variables resistencias,
    % temperaturas e intensidades.
    ADAPROX=zeros (2*m*n+n+m,3);
    fprintf(1,'Peticin de la aproximaciones de la/s intensidad/es de la/s resistencia/s y de la/s temperatura/s\n');
    fprintf(1,'Siga por favor las instrucciones adecuadamente\n');
    fprintf(1,'\n');
    fprintf(1,'1 El fichero tendr 3 columnas de nmeros\n');
    fprintf(1,'2 El fichero tendr 2*m*n+n+m filas (el nmero aristas totales o el nmero mximo de resistencias en el circuito )\n');
    fprintf(1,'3 Deje una separacin entre cada uno de los nmeros de cada fila\n');
    fprintf(1,'4 Las filas coinciden con la numeracin de las resistencias y por tanto de las temperaturas\n');
    fprintf(1,'5 Para las intensidades el nmero de la intensidad coincide con la fila\n');
    fprintf(1,'6 El orden de las columnas es aproximaciones de las resistencias, temperaturas e intensidades\n');
    fprintf(1,'7 En caso de que no exista una resistencia en su circuito, las aproximaciones  \n');
    fprintf(1,'   de temperatura y resistencia sern cero \n');
    fprintf(1,'8 Para la columna de las intensidades, se pondrn m*n valores de las aproximaciones, y el\n');
    fprintf(1,'   resto de posiciones hasta las 2*m*n+n+m filas, se pondrn ceros \n');
    fprintf(1,'\n');
    fprintf(1,'Ahora se pedirn los datos comentados\n');
    fprintf(1,'Escriba el nombre del fichero en la forma - disco:\\nombre.ext\n');
    fprintf(1,'Por ejemplo:   A:\\DATA.DTA\n');
    NAME = input(' ','s');
    INP = fopen(NAME,'rt');
    for i = 1 : 2*m*n+n+m
        for j = 1:3
            ADAPROX(i,j) = fscanf(INP, '%f',1);
        end
    end
    fclose(INP);
    for i=1: 2*m*n+n+m
        R(i,1)=ADAPROX(i,1);
        T(i,1)=ADAPROX(i,2);
    end
    for i=1: m*n
        I(i,1)=ADAPROX(i,3);
    end
end
% Inicio del encadenamiento para la solucin del jacobiano
% X es el vector de incgnitas en el jacobiano
X=zeros(5*n*m+2*m+2*n,1);
% W representa el vector de comprobacin de la solucin obtenida con la 
W=zeros(5*n*m+2*m+2*n,1);
fprintf ('escriba por favor el valor de la tolerancia h\n')
h=input('');
fprintf('escriba el n mximo de iteraciones g\n')
g=input('');
g=g-1;
% l es el contador del nmero de iteraciones
z=0;
l=0;
error=1e10;
while l<=g & error>h
        l=l+1;
        % Obtencin de los valores de la matriz solucin del jacobiano de las funciones resistencia 
        for i=1:2*n*m+n+m
            f(i,1)=-R(i,1)+DR(i,1)+DR(i,2)*T(i,1)+DR(i,3)*[T(i,1)]^2;
        end
        % Obtencin de los valores de la matriz solucin del jacobiano de las
        % funciones potencia
        k=2*m*n+n+m;
        for i= k+1:2*k
            if  O(i-k,1)==O(i-k,2)
                f(i,1)= -R(i-k,1)*(I(O(i-k,1)))^2 + DR(i-k,4)*(5.67*10^-8)*(T(i-k,1)^4-298^4)+DR(i-k,4)*20*(T(i-k,1)-298);
            else
                f(i,1)= -R(i-k,1)*(I(O(i-k,1),1)-I(O(i-k,2),1))^2+DR(i-k,4)*5.67*10^-8*(((T(i-k,1))^4)-298^4)+DR(i-k,4)*20*(T(i-k,1)-298);
            end
        end
        % Obtencin de los valores de la matriz solucin del jacobiano de las
        % funciones de kirchoff
        k=4*m*n +2*m+2*n;
        u=1;
        for i=k+1:k+m*n
             f(i,1)=(R(C(u,1),1)+R(C(u,2),1)+R(C(u,3),1)+R(C(u,4),1))*I(u,1); 
             for j=1:4
                if O(C(u,j),1)~= O(C(u,j),2)
                    if O(C(u,j),1)~=u
                        f(i,1)=f(i,1)-R(C(u,j),1)*I(O(C(u,j),1),1);
                    end
                    if O(C(u,j),2)~=u
                        f(i,1)=f(i,1)-R(C(u,j),1)*I(O(C(u,j),2),1);
                    end
                end
             end
             f(i,1)=f(i,1)-V(C(u,2),1)+V(C(u,3),1)+V(C(u,1),1)-V(C(u,4),1);
             u=u+1; 
        end
        % Matriz indicadora de soluciones de X con tolerancia adecuada
        % Si no cumplen las variables con las tolerncias impuestas
            % Obtencin de la matriz derivadas 
            % Ahora introducimos para la funcin resistencia
            % f= -Rj+aj+bj*Tj+cj*Tj^2
            % las derivadas parciales de R y T? f=f(Rj,Tj)
            % y para la funcin potencia que es f(Tj,Rj,Ij)
            DP=zeros(5*n*m+2*m+2*n,5*n*m+2*m+2*n);
            k=2*n*m+n+m;
            for i=1:2*n*m+n+m
                DP(i,i)=-1;
                DP(i,i+k)=DR(i,2)+2*DR(i,3)*T(i,1);
                DP(i+k,i+k)=DR(i,4)*(5.67*10^-8)*(4)*T(i,1)^3+DR(i,4)*20;
                if O(i,1)==O(i,2)
                    DP(i+k, O(i,1)+2*k)=-2*R(i,1)*I(O(i,1),1);
                    DP(i+k,i)=-I(O(i,1),1)^2;
                elseif O(i,1) ~= O(i,2)
                    DP(i+k,i)=-(I(O(i,1),1)-I(O(i,2),1))^2;
                    if I(O(i,1),1)>=I(O(i,2),1)
                        DP(i+k,O(i,1)+2*k)=-2*R(i,1)*(I(O(i,1),1)-I(O(i,2),1));
                        DP(i+k,O(i,2)+2*k)=2*R(i,1)*(I(O(i,1),1)-I(O(i,2),1));                                          
                    else
                        DP(i+k,O(i,2)+2*k)= -2*R(i,1)*(I(O(i,2),1)-I(O(i,1),1));
                        DP(i+k,O(i,1)+2*k)= 2*R(i,1)*(I(O(i,2),1)-I(O(i,1),1));
                    end
                end
            end
            % Derivadas de la funcin de kirchoff
            k=4*m*n+2*n+2*m;
            for i=1:m*n
                DP(i+k,i+k)=R(C(i,1),1)+R(C(i,2),1)+ R(C(i,3),1)+R(C(i,4),1);
                for j=1:4
                    if O(C(i,j),1)==O(C(i,j),2)
                        DP(i+k,C(i,j))=I(i,1);
                    else
                        if O(C(i,j),1)~=i
                            DP(i+k,C(i,j))=I(i,1)-I(O(C(i,j),1));
                            DP(i+k,k+O(C(i,j),1))=-R(C(i,j),1);
                        else
                            DP(i+k,C(i,j))=I(i,1)-I(O(C(i,j),2));
                            DP(i+k,k+O(C(i,j),2))=-R(C(i,j),1);
                        end
                    end
                end
            end
            for i=1:5*n*m+2*n+2*m
                if f(i)==0
                    DP(i,i)=1;
                end
            end
            X=inv(DP)*(-f);
            for j=1:2*n*m+m+n
                T(j,1)=T(j,1)+X(2*n*m+m+n+j,1);
                R(j,1)=R(j,1)+X(j,1);
            end
            for j=1:m*n
                I(j,1)= I(j,1)+X(4*m*n+2*n+2*m+j,1);
            end
            error=norm(f,inf);
end
% Disposicin de los resultados, se llegue o no a cumplir la tolencia
% prevista.
% RES es la matriz de resultados, en la columna 3, parte de ella sern
% ceros, pues hay ms valores de Tj y Rj, que de Ij. 
RES=zeros(2*n*m+n+m,3);
for i=1:2*m*n+n+m
    RES(i,1)=T(i,1);
    RES(i,2)=R(i,1);
end
for i=1:m*n
    RES(i,3)=I(i,1);
end
if error>h
	fprintf ('no se cumple la tolerancia impuesta por el usuario\n')
else
	fprintf ('se cumple la tolerancia impuesta por el usuario\n')
end
fprintf ('El numero de iteraciones realizadas\n')
l=l
fprintf ('Se corresponde la matriz resultados, siendo la primera columna\n')
fprintf ('para la temperatura, la segunda para las resistencias, y la tercera\n ')
fprintf ('para la intensidad, slo las m*n filas primeras, debern presentar\n ')
fprintf ('valores iguales o distintos a cero, el resto ser cero, pues no\n')
fprintf ('representan nada\n')
RES=RES            

fprintf(1,'A continuacion presionar "1" para que muestre el grafico con las soluciones correspondientes\n');
zz=input(' ');
if zz==1
    close    
    i = m;
    j = n;
    TRUE = 1;
    FALSE = 0;    
    title('malla de tensiones y resistecias');
    xlabel('columnas');
    ylabel('filas');
    axis([-1 m+1 -1 n+1]);%pone ejes hasta m+1 y n+1
    hold on;
    while j ~= -1;
        i = m;
        while i~=0;%hace m lineas
            x=[i-0.05 i-0.95];%coordinadas x de 1 linea
            y=[j j];%coordenadas y de una linea
            plot(x,y);
            i=i-1;

        end;
        j=j-1;
    end;
    i=m;
    while i~=-1
        j=n;
        while j~=0;%hace n colunmas
            y=[j-0.05 j-0.95];%coordinadas y de lineas horizontales
            x=[i i];%coordinadas x de lineas horizontales
            plot(x,y);
            j=j-1;
        end;
        i=i-1;
    end;
end

% A continuacion lo que se pretenda es mostrar en la grafica las
% resistencias de cada arista
% Nos quedamos unicamente con la columna de las resistencias
RDB1=zeros(1,2*m*n+n+m);

for i=1:2*m*n+n+m  
     RDB1(1,i)=RES(i,2);
end
p=num2str(RDB1); % Pasamos el vector entero a vector cadena
h=isspace(p); % Devuelve uno si los elementos de R son espacios en blanco y cero en caso contrario
z=length(h); % Longitud del vector de unos y ceros
e=1; % Contador que nos muestra la posicion del vector p y h
b=0;
c=0.25;
for a=1:n+1
    for j=0:(m-1)
            x=j+0.25;
            while h(e)==0 & e<=z-1
                    y=n+b;
                    text(x,y,p(e),'Color',[1 0 1]); % Inserta cada resistencia en horizontal,en su respectivo lugar
                    x=x+0.1;
                    e=e+1;

            end
            while h(e)==1 & e<=z-1
                e=e+1;
            end
            if e==z & j==m-1
                y=(n+b);
                text(x,y,p(z),'Color',[1 0 1]); % Inserta la ultima resistencia
                      
            end
     end

    for i=0:m
         x=i;
           while h(e)==0 & e<=z-1 % Si es un 1, simplemente aumentamos el contador de e

                    y=(n-1)+c;               
                    text(x,y,p(e),'Color',[1 0 1]); % Inserta cada resistencia en vertical,en su respectivo lugar
                    x=x+0.1;
                    e=e+1;

            end
            while h(e)==1 & e<=z-1 % Si es un 1, simplemente aumentamos el contador de e
                e=e+1;
            end
        end
    b=b-1;
    c=c-1;
end

%TENSIONES%

RDB2=zeros(1,2*m*n+n+m);
for i=1:2*n*m+n+m
     RDB2(1,i)=V(i,1);
 end
p=num2str(RDB2);
h=isspace(p);
z=length(h);
e=1;
b=0;
c=0.5;
for a=1:n+1

    for j=0:(m-1)
            x=j+0.5;
            
           while h(e)==0 & e<=z-1

                    y=n+b;
                    
                    text(x,y,p(e),'Color',[1 0 0]);
                    x=x+0.1;
                    e=e+1;

            end
            while h(e)==1  & e<=z-1
                e=e+1;
            end
            if e==z & j==m-1
                y=n+b;
                
                text(x,y,p(z),'Color',[1 0 0]);
                      
            end
     end

    for i=0:(m)
         x=i;
           while h(e)==0 & e<=z-1

                    y=(n-1)+c;
                    text(x,y,p(e),'Color',[1 0 0]);
                    x=x+0.1;
                    e=e+1;

            end
            while h(e)==1 & e<=z-1
                e=e+1;
            end
        end

    b=b-1;
    c=c-1;
end

%INTENSIDADES%

RDB3=zeros(1,m*n);
for i=1:m*n  
     RDB3(1,i)=RES(i,3);
end
Int=num2str(RDB3);%Convertimos el vector intensidad en vector cadena
h=isspace(Int);%Vector de ceros y unos
w=length(h);% Longitud del vector h
A=0;
b=0.5;
e=1;% Contador del vector intensidad y h
for t=1:n
    for j=0:(m-1)
            x=j+0.4;
            
           while h(e)==0 & e<=w-1

                    y=b+(n-1);
                    
                    text(x,y,Int(e),'Color',[0 1 0]);% Se inserta el valor de cada intensidad en el centro de cada celda
                    x=x+0.1;
                    e=e+1;

            end
            while h(e)==1 & e<=w-1
                e=e+1;
            end
            if e==w & j==m-1
                y=-y+b;
                text(x,y,Int(w),'Color',[0 1 0]); %Se inserta el valor de la ultima intensidad en su celda correspondiente 
                      
            end
     end
     b=b-1;
 end
 

