syms('m','n','i','j','x','y','I','l','z','s','I');
syms('AA', 'NAME', 'INP', 'OK', 'N', 'I', 'J', 'A','B','C','D', 'NN','NA');
syms('k','f','d','j','x','y','i','v','M','N','e','a','w');
syms('KK', 'S', 'K', 'JJ', 'FLAG', 'OUP', 's','Z');
fprintf(1,'Este programa resuelve un circuito electrico a partir de  sus resistencias\n');
fprintf(1,'y de sus tensiones, insertandolas en un fichero de texto. Ademas es capaz de mostrar dicho circuito  \n');
fprintf(1,'graficamente, visualizando las intensidades que circulan por cada malla.\n');
fprintf(1,'Introducir columnas (M) y filas (N) en lineas separadas\n');
m = input(' ');
n = input(' ');
i = m;
j = n;
TRUE = 1;
FALSE = 0;
close;%cierra pantallas anteriores
title('malla de tensiones y resistecias');
xlabel('columnas');
ylabel('filas');
axis([-1 m+1 -1 n+1]);%pone ejes hasta m+1 y n+1
hold on;
while j ~= -1;
    i = m;
    while i~=0;%hace m lineas
        x=[i-0.05 i-0.95];%coordinadas x de 1 linea
        y=[j j];%coordenadas y de una linea
        plot(x,y);
        i=i-1;

    end;
    j=j-1;
end;
i=m;
while i~=-1
    j=n;
    while j~=0;%hace n colunmas
        y=[j-0.05 j-0.95];%coordinadas y de lineas horizontales
        x=[i i];%coordinadas x de lineas horizontales
        plot(x,y);
        j=j-1;
    end;
      i=i-1;
end;
%segunda parte
%declaracion de las aristas de cada celda, las cuales han sido numeradas
for i=1:n%numeracion de aristas
    for j=1:m
        C=(i-1)*m+j;
        L(C,1)=j+(2*m+1)*(i-1);
        L(C,2)=j+m+1+(2*m+1)*(i-1);
        L(C,3)=j+(2*m+1)*i;
        L(C,4)=j+m+(2*m+1)*(i-1);
    end
end
NA=2*m*n+m+n;% siendo NA el numero de aristas,
%
fprintf(1,'    El fichero debe tener dos columnas: la primera para las resistencias \n');
fprintf(1,'y la segunda para las tensiones.\n');
fprintf(1,'    Los datos de las resistencias y de las tensiones se introduciran \n');
fprintf(1,'de izquierda a derecha y de abajo a arriba, primero las aristas horizontales \n');
fprintf(1,'y luego las verticales. \n');
fprintf(1,'     Las intensidades de cada malla tendran sentido antihorario \n');
fprintf(1,'     El criterio de signos utilizados en las tensiones sera el siguiente: \n');
fprintf(1,'     En las aristas horizontales se consideraran posistivas si el polo posistivo \n');
fprintf(1,'esta situado en el lado derecho. En las aristas verticales el positivo se encuentra en la \n');
fprintf(1,'parte superior \n');
fprintf(1,'    Por ejemplo: en una matriz de 21, primero introduciremos \n');

fprintf(1,'los dos valores (resistencias y tensiones) de las dos aristas horizontales inferiores, \n');
fprintf(1,'de izquierda a derecha. \n');
fprintf(1,'    A continuacion, se insertan los 3 valores de las aristas verticales,y \n');
fprintf(1,'por ultimo los de las dos aristas horizontales superiores. \n');
fprintf(1,'Se ha creado ya el fichero de entrada? - escriba Y o N.\n');
AA = input(' ','s');
if AA == 'Y' | AA == 'y'
fprintf(1,'Escriba el nombre del fichero de la forma -disco:\\nombre.ext\n');
fprintf(1,'for example:   A:\\DATA.DTA\n');
NAME = input(' ','s');
INP = fopen(NAME,'rt');
end

R=zeros(NA);clc
T=zeros(NA);

for i=1:NA
    R(i)=fscanf(INP, '%f',1);
    T(i)=fscanf(INP, '%f',1);
end


fclose(INP);

A=zeros(m*n,m*n+1);%matriz de resistencias

X=zeros(m*n);

for i=1:(m*n)
    A(i,i)=R(L(i,1))+R(L(i,2))+R(L(i,3))+R(L(i,4));%diagonal de la matriz
           C1=i-m;
           C2=i+1;
           C3=i+m;
           C4=i-1;
           CC1=1;
           CC2=1;
           CC3=1;
           CC4=1;
        if C1<=0;%
            CC1=0;
        end
        if C3>m*n;
            CC3=0;
        end
        if (i/m)==int16(i/m);
            CC2=0;
        end
        if ((i-1)/m)==int16((i-1)/m);
            CC4=0;
        end

        if CC1~=0;
           A(i,C1)=-R(L(i,1));
        end
        if CC2~=0
           A(i,C2)=-R(L(i,2));
        end
        if CC3~=0
           A(i,C3)=-R(L(i,3));
        end
        if CC4~=0
           A(i,C4)=-R(L(i,4));
       end
   A(i,m*n+1)=T(L(i,1))+T(L(i,2))-T(L(i,3))-T(L(i,4));
end
Matriz=A;
Matriz
newn=m*n;
% PASO 1
A(1,1) = sqrt(A(1,1));
% PASO 2
for J = 2 : newn
A(J,1) = A(J,1)/A(1,1);
end;
% PASO 3
NN = newn-1;
for I = 2 : NN
% PASO 4
KK = I-1;
S = 0;
for K = 1 : KK
S = S-A(I,K)*A(I,K);
end;
A(I,I) = sqrt(A(I,I)+S);
% PASO 5
JJ = I+1;
for J = JJ : newn
S = 0;
KK = I-1;
for K = 1 : KK
S = S - A(J,K)*A(I,K);
end;
A(J,I) = (A(J,I)+S)/A(I,I);
end;
end;
% PASO 6
S = 0;
for K = 1 : NN
S = S-A(newn,K)*A(newn,K);
end;
A(newn,newn) = sqrt(A(newn,newn)+S);
% ________________________________________________________________________
x = zeros(1,newn);
y = zeros(1,newn);
% Sustitucion hacia delante.
y(1)=A(1,newn+1)/A(1,1);
for I=2:newn
   S=A(I,newn+1);
   for J=1:I-1
      S=S-A(I,J)*y(J);
   end;
   y(I)=S/A(I,I);
end;
% Sustitucion hacia detras.
x(newn)=y(newn)/A(newn,newn);
for I=newn-1:-1:1
   S=y(I);
   for J=I+1:newn
      S=S-A(J,I)*x(J);
   end;
   x(I)=S/A(I,I);
end;
Intensidades=x;
Intensidades
%   RESISTENCIAS

% A continuacion lo que se pretenda es mostrar en la grafica las
% resistencias de cada arista

 for i=2:NA  % Nos quedamos unicamente con la columna de las resistencias
     R(:,2)=[];
 end
 R=R';% Trasponemos la columna
p=num2str(R); % Pasamos el vector entero a vector cadena
h=isspace(p); % Devuelve uno si los elementos de R son espacios en blanco y cero en caso contrario
z=length(h); % Longitud del vector de unos y ceros
e=1; % Contador que nos muestra la posicion del vector p y h
b=0;
c=0.25;
for a=1:n+1

    for j=0:(m-1)
            x=j+0.25;
            
           while h(e)==0 && e<=z-1

                    y=b;
                    
                    text(x,y,p(e),'Color',[1 0 1]); % Inserta cada resistencia en horizontal,en su respectivo lugar
                    x=x+0.1;
                    e=e+1;

            end
            while h(e)==1 && e<=z-1
                e=e+1;
            end
            if e==z && j==m-1
                y=b;
                text(x,y,p(z),'Color',[1 0 1]); % Inserta la ultima resistencia
                      
            end
     end

    for i=0:(m)
         x=i;
           while h(e)==0 && e<=z-1 % Si es un 1, simplemente aumentamos el contador de e

                    y=c;
                                     
                    text(x,y,p(e),'Color',[1 0 1]); % Inserta cada resistencia en vertical,en su respectivo lugar
                    x=x+0.1;
                    e=e+1;

            end
            while h(e)==1 && e<=z-1 % Si es un 1, simplemente aumentamos el contador de e
                e=e+1;
            end
        end

    b=b+1;
    c=c+1;
end

% TENSIONES

% Repetimos el proceso realizado anteriormente con las resistencias

 for i=2:NA
     T(:,2)=[];
 end
 T=T';
p=num2str(T);
h=isspace(p);
z=length(h);
e=1;
b=0;
c=0.5;
for a=1:n+1

    for j=0:(m-1)
            x=j+0.5;
            
           while h(e)==0 && e<=z-1

                    y=b;
                    
                    text(x,y,p(e),'Color',[1 0 0]);
                    x=x+0.1;
                    e=e+1;

            end
            while h(e)==1 && e<=z-1
                e=e+1;
            end
            if e==z && j==m-1
                y=b;
                
                text(x,y,p(z),'Color',[1 0 0]);
                      
            end
     end

    for i=0:(m)
         x=i;
           while h(e)==0 && e<=z-1

                    y=c;
                    
                    
                    text(x,y,p(e),'Color',[1 0 0]);
                    x=x+0.1;
                    e=e+1;

            end
            while h(e)==1 && e<=z-1
                e=e+1;
            end
        end

    b=b+1;
    c=c+1;
end
% INTENSIDADES
%Se insertara las inten de cada celda en la grafica

Int=num2str(Intensidades);%Convertimos el vector intensidad en vector cadena
h=isspace(Int);%Vector de ceros y unos
w=length(h);% Longitud del vector h
A=0;
b=0.5;
e=1;% Contador del vector intensidad y h
for t=1:n
    for j=0:(m-1)
            x=j+0.2;
            
           while h(e)==0 && e<=w-1

                    y=b;
                    
                    text(x,y,Int(e),'Color',[0 1 0]);% Se inserta el valor de cada intensidad en el centro de cada celda
                    x=x+0.1;
                    e=e+1;

            end
            while h(e)==1 && e<=w-1
                e=e+1;
            end
            if e==w && j==m-1
                y=b;
                text(x,y,Int(w),'Color',[0 1 0]); %Se inserta el valor de la ultima intensidad en su celda correspondiente 
                      
            end
     end
     b=b+1;
 end
 
 % LEYENDA
 text(-0.9,-0.75,'Intensidades','Color',[0 1 0]);
 text(-0.9,-0.5,'Resistencias','Color',[1 0 1]);
 text(-0.9,-0.25,'Intensidades','Color',[1 0 0]);
 

